﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/match/messages_match.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/match/popup_match.ini")

cheers = [
	"bot/whoo.wav",
	"bot/whoo2.wav",
	"bot/yesss.wav",
	"bot/yesss2.wav",
	"bot/and_thats_how_its_done.wav",
	"bot/enemy_down2.wav",
	"bot/good_job_team.wav",
	"bot/nice.wav",
	"bot/nice2.wav",
	"bot/nice_work_team.wav",
	"bot/oh_yea.wav",
	"bot/oh_yea2.wav",
	"bot/owned.wav",
	"bot/very_nice.wav",
	"bot/we_owned_them.wav",
	"bot/yea_baby.wav"
]

# ******************** Load ********************
def load():
	es.set("sm_match_started", 0)
	es.set("sm_match_paused", 0)
	es.set("sm_match_paused_delay", 0)

	es.set("sm_match_period", 1)
	es.set("sm_match_period_time", 0)
	es.set("sm_match_period_break", 0)
	es.set("sm_match_golden_goal", 0)

	es.set("sm_match_minutes", 0)
	es.set("sm_match_seconds", 0)

	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)

	create_popup()
	create_popup_win()
	create_popup_lose()

	es.load("soccer_mod_2011/modules/match/names")
	es.load("soccer_mod_2011/modules/match/score")

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_match")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("start")))
	popup.addline("->2. %s" % (popup_text("pause")))
	popup.addline("->3. %s" % (popup_text("unpause")))
	popup.addline("->4. %s" % (popup_text("names")))
	popup.addline("->5. %s" % (popup_text("score")))
	popup.addline("->6. %s" % (popup_text("stop")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)
	popup.select(2, popup_choice)
	popup.select(3, popup_choice)
	popup.submenu(4, "sm_popup_admin_match_names")
	popup.submenu(5, "sm_popup_admin_match_score")
	popup.select(6, popup_choice)

	for i in range(7, 9):
		popup.submenu(i, "sm_popup_admin_match")

	popup.submenu(9, "sm_popup_admin")

def create_popup_win():
	popup = popuplib.create("sm_popup_match_win")

	popup.addline("SOCCER MOD %s" % (popup_text("title_win")))
	popup.addline(" ")
	popup.addline(popup_text("beer"))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_common("yes")))
	popup.addline("->2. %s" % (popup_common("no")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, beer)

	for i in range(3, 10):
		popup.submenu(i, "sm_popup_match_win")

def create_popup_lose():
	popup = popuplib.create("sm_popup_match_lose")

	popup.addline("SOCCER MOD %s" % (popup_text("title_lose")))
	popup.addline(" ")
	popup.addline(popup_text("end"))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_common("yes")))
	popup.addline("->2. %s" % (popup_common("no")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, fireworks)

	for i in range(3, 10):
		popup.submenu(i, "sm_popup_match_lose")

# ******************** Events ********************
def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_started") == 1:
			if es.ServerVar("sm_match_paused") == 1 or es.ServerVar("sm_match_period_break") == 1:
				player = playerlib.getPlayer(event_var["userid"])
				player.freeze(1)

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		es.server.queuecmd("phys_pushscale 900")
		es.server.queuecmd("phys_timescale 1")

		es.server.queuecmd("score set #t %s" % (es.ServerVar("sm_match_score_t")))
		es.server.queuecmd("score set #ct %s" % (es.ServerVar("sm_match_score_ct")))

		if es.ServerVar("sm_match_sounds_on") == 1:
			es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_round_start"))

		es.set("sm_match_goal_scored", 0)

		players = playerlib.getUseridList("#all")
		if len(players) > 0:
			userid = random.choice(players)
			es.server.queuecmd('es_xfire %s trigger_hurt addoutput "OnStartTouch point_servercommand,command,es_xset sm_match_goal_scored 1"' % (userid))

		if es.ServerVar("sm_match_started") == 1:
			if es.ServerVar("sm_match_kick_off_msg") == 1:
				if es.ServerVar("sm_match_golden_goal") == 1:
					toss = random.randint(0, 1)
					if toss % 2 == 0:
						team = es.ServerVar("sm_match_name_t")
					else:
						team = es.ServerVar("sm_match_name_ct")
				else:
					if es.ServerVar("sm_match_period") % 2 == 0:
						if es.ServerVar("sm_match_toss") == 0:
							team = es.ServerVar("sm_match_name_t")
						else:
							team = es.ServerVar("sm_match_name_ct")
					else:
						if es.ServerVar("sm_match_toss") == 0:
							team = es.ServerVar("sm_match_name_ct")
						else:
							team = es.ServerVar("sm_match_name_t")

				tokens = {}
				tokens["team"] = team
				lang_msg.tell(messages_text, "kick_off", tokens)
				lang_msg.centertell(messages_text, "kick_off", tokens)
				es.set("sm_match_kick_off_msg", 0)

			es.set("sm_match_first_hit", 0)

			if len(players) > 0:
				es.server.queuecmd('es_xfire %s func_physbox addoutput "OnDamaged point_servercommand,command,es_xdoblock soccer_mod_2011/modules/match/ball_hit"' % (userid))
				es.server.queuecmd('es_xfire %s prop_physics addoutput "OnTakeDamage point_servercommand,command,es_xdoblock soccer_mod_2011/modules/match/ball_hit"' % (userid))

			if es.ServerVar("sm_match_period_break") == 0:
				gamethread.cancelDelayed("sm_match")
				period_timer(es.ServerVar("sm_match_period_time"), False)

			if es.ServerVar("sm_match_paused") == 1 or es.ServerVar("sm_match_period_break") == 1:
				freeze()

def round_end(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		match = es.ServerVar("sm_match_started")

		if match == 1:
			if es.ServerVar("sm_match_period_break") == 0:
				gamethread.cancelDelayed("sm_match")
				period_timer(es.ServerVar("sm_match_period_time"), False)

		winner = int(event_var["winner"])

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		if winner > 1:
			if int(es.ServerVar("sm_match_goal_scored")) == 1:
				tokens = {}

				if winner == 2:
					score_t += 1
					es.set("sm_match_score_t", score_t)

					tokens["team"] = es.ServerVar("sm_match_name_t")

				elif winner == 3:
					score_ct += 1
					es.set("sm_match_score_ct", score_ct)

					tokens["team"] = es.ServerVar("sm_match_name_ct")

				short_name_t = es.ServerVar("sm_match_short_name_t")
				short_name_ct = es.ServerVar("sm_match_short_name_ct")

				if es.ServerVar("sm_match_swap_names_on") == 0:
					tokens["score"] = "%s %s - %s %s" % (short_name_t, score_t, score_ct, short_name_ct)
				else:
					tokens["score"] = "%s %s - %s %s" % (short_name_ct, score_ct, score_t, short_name_t)

				if match == 1:
					minutes = es.ServerVar("sm_match_minutes")
					seconds = es.ServerVar("sm_match_seconds")

					if seconds < 10:
						tokens["time"] = "%s:0%s" % (minutes, seconds)
					else:
						tokens["time"] = "%s:%s" % (minutes, seconds)

					lang_msg.tell(messages_text, "match_goal_scored", tokens)

					if es.ServerVar("sm_match_golden_goal") == 1:
						display_score_board(minutes, seconds)

						if winner == 2:
							win_t()
						elif winner == 3:
							win_ct()
				else:
					lang_msg.tell(messages_text, "goal_scored", tokens)

				if es.ServerVar("sm_match_sounds_on") == 1:
					if winner == 2:
						for player in playerlib.getPlayerList("#alive,#t"):
							sound = random.randint(0, (len(cheers) - 1))
							es.emitsound("player", player.userid, cheers[sound], 1, 0.5)
					else:
						for player in playerlib.getPlayerList("#alive,#ct"):
							sound = random.randint(0, (len(cheers) - 1))
							es.emitsound("player", player.userid, cheers[sound], 1, 0.5)

					es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_round_end"))
		else:
			if match == 0:
				es.set("sm_match_score_t", 0)
				es.set("sm_match_score_ct", 0)

				score_t = 0
				score_ct = 0

		es.server.queuecmd("score set #t %s" % (score_t))
		es.server.queuecmd("score set #ct %s" % (score_ct))

# ******************** Commands ********************
def cmd_start():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_public_start_on") == 1:
			start(userid)
		else:
			if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
				try:
					if int(es.keygetvalue("soccer_mod_admins", player.steamid, "match")) == 1:
						start(userid)
					else:
						es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
				except ValueError:
					es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("start_off", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

def cmd_pause():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_public_pause_on") == 1:
			pause(userid)
		else:
			if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
				try:
					if int(es.keygetvalue("soccer_mod_admins", player.steamid, "match")) == 1:
						pause(userid)
					else:
						es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
				except ValueError:
					es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("pause_off", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

def cmd_unpause():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_public_unpause_on") == 1:
			unpause(userid)
		else:
			if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
				try:
					if int(es.keygetvalue("soccer_mod_admins", player.steamid, "match")) == 1:
						unpause(userid)
					else:
						es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
				except ValueError:
					es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("unpause_off", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

def cmd_stop():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_public_stop_on") == 1:
			stop(userid)
		else:
			if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
				try:
					if int(es.keygetvalue("soccer_mod_admins", player.steamid, "match")) == 1:
						stop(userid)
					else:
						es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
				except ValueError:
					es.tell(userid, "#green", messages_text("not_allowed_match", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("stop_off", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	if choice == 1:
		start(userid)
	elif choice == 2:
		pause(userid)
	elif choice == 3:
		unpause(userid)
	elif choice == 6:
		stop(userid)

	popuplib.send("sm_popup_admin_match", userid)

def beer(userid, choice, popupid):
	player = playerlib.getPlayer(userid)
	es.centertell(userid, messages_text("beer", None, player.get("lang")))

	change_view(userid)
	gamethread.delayed(0.2, change_view, (userid))
	gamethread.delayed(0.4, change_view, (userid))
	gamethread.delayed(0.6, change_view, (userid))
	gamethread.delayed(0.8, change_view, (userid))
	gamethread.delayed(1, change_view, (userid))
	gamethread.delayed(1.2, change_view, (userid))
	gamethread.delayed(1.4, change_view, (userid))
	gamethread.delayed(1.6, change_view, (userid))
	gamethread.delayed(1.8, change_view, (userid))
	gamethread.delayed(2, change_view, (userid))
	gamethread.delayed(2.2, change_view, (userid))
	gamethread.delayed(2.4, change_view, (userid))
	gamethread.delayed(2.6, change_view, (userid))
	gamethread.delayed(2.8, change_view, (userid))
	gamethread.delayed(3, change_view, (userid))
	gamethread.delayed(3.2, change_view, (userid))
	gamethread.delayed(3.4, change_view, (userid))
	gamethread.delayed(3.6, change_view, (userid))
	gamethread.delayed(3.8, change_view, (userid))
	gamethread.delayed(4, change_view, (userid))
	gamethread.delayed(4.2, change_view, (userid))
	gamethread.delayed(4.4, change_view, (userid))
	gamethread.delayed(4.6, change_view, (userid))
	gamethread.delayed(4.8, change_view, (userid))
	gamethread.delayed(5, change_view, (userid, 90))

def fireworks(userid, choice, popupid):
	player = playerlib.getPlayer(userid)
	es.centertell(userid, messages_text("fireworks", None, player.get("lang")))

	es.server.queuecmd("usermsg shake %s 100 2" % (userid))

	if es.ServerVar("sm_module_referee_on") == 1:
		es.emitsound("player", userid, es.ServerVar("sm_referee_sound_fireworks"), "1.0", "0.5")

	push_player(userid, 5)
	gamethread.delayed(0.1, push_player, (userid, 20))
	gamethread.delayed(0.2, push_player, (userid, 45))
	gamethread.delayed(0.3, push_player, (userid, 80))
	gamethread.delayed(0.4, push_player, (userid, 125))
	gamethread.delayed(0.5, push_player, (userid, 180))
	gamethread.delayed(0.6, push_player, (userid, 245))
	gamethread.delayed(0.7, push_player, (userid, 320))
	gamethread.delayed(0.8, push_player, (userid, 405))
	gamethread.delayed(0.9, push_player, (userid, 500))
	gamethread.delayed(1, push_player, (userid, 605))
	gamethread.delayed(1.1, push_player, (userid, 720))
	gamethread.delayed(1.2, push_player, (userid, 845))
	gamethread.delayed(1.3, push_player, (userid, 980))
	gamethread.delayed(1.4, push_player, (userid, 1125))
	gamethread.delayed(1.5, push_player, (userid, 1280))
	gamethread.delayed(1.6, push_player, (userid, 1445))
	gamethread.delayed(1.7, push_player, (userid, 1620))
	gamethread.delayed(1.8, push_player, (userid, 1805))
	gamethread.delayed(1.9, push_player, (userid, 2000))

	gamethread.delayed(2.5, explosion, (userid))
	gamethread.delayed(2.5, kill_player, (userid))

# ******************** Functions ********************
def start(userid):
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_cap_fight_started") == 0:
		if es.ServerVar("sm_training_cannon_on") == 0:
			if es.ServerVar("sm_training_goals_disabled") == 0:
				if es.exists("keygroup", "sm_keygroup_vote") == 0:
					if es.ServerVar("sm_match_started") == 0:
						freeze()

						es.set("sm_match_started", 1)
						es.set("sm_match_paused", 0)
						es.set("sm_match_paused_delay", 0)
						es.set("sm_match_first_hit", 1)

						es.set("sm_match_period", 1)
						es.set("sm_match_period_time", 0)
						es.set("sm_match_period_break", 0)
						es.set("sm_match_golden_goal", 0)

						es.set("sm_match_minutes", 0)
						es.set("sm_match_seconds", 0)

						es.set("sm_match_score_t", 0)
						es.set("sm_match_score_ct", 0)

						es.set("sm_match_kick_off_msg", 1)
						es.set("sm_match_toss", random.randint(0, 1))

						tokens = {}

						periods = int(es.ServerVar("sm_match_periods"))
						tokens["periods"] = periods

						length = periods * int(es.ServerVar("sm_match_period_length"))
						minutes = int(length / 60)
						seconds = int(length - (minutes * 60))

						if seconds < 10:
							tokens["length"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["length"] = "%s:%s" % (minutes, seconds)

						length = int(es.ServerVar("sm_match_period_break_length"))
						minutes = int(length / 60)
						seconds = int(length - (minutes * 60))

						if seconds < 10:
							tokens["break_length"] = "%s:0%s" % (minutes, seconds)
						else:
							tokens["break_length"] = "%s:%s" % (minutes, seconds)

						lang_msg.hudhint(messages_text, "match_message", tokens)

						tokens["name"] = player.name
						lang_msg.tell(messages_text, "match_started", tokens)

						if es.ServerVar("sm_match_swap_names_on") == 0:
							es.msg("#green", "%s - %s" % (es.ServerVar("sm_match_name_t"), es.ServerVar("sm_match_name_ct")))
						else:
							es.msg("#green", "%s - %s" % (es.ServerVar("sm_match_name_ct"), es.ServerVar("sm_match_name_t")))

						es.server.queuecmd("mp_restartgame %s" % (es.ServerVar("sm_match_restart_length")))

						if es.ServerVar("sm_module_stats_on") == 1:
							es.doblock("soccer_mod_2011/modules/stats/reset")
					else:
						es.tell(userid, "#green", messages_text("already_started", None, player.get("lang")))
				else:
					es.tell(userid, "#green", messages_text("vote_active", None, player.get("lang")))
			else:
				es.tell(userid, "#green", messages_text("no_match_goals_disabled", None, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_text("no_match_cannon_on", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("no_match_cap_fight", None, player.get("lang")))

def pause(userid):
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 1:
		if es.ServerVar("sm_match_paused") == 0:
			es.set("sm_match_paused", 1)

			if es.ServerVar("sm_match_period_break") == 0:
				freeze()
				gamethread.cancelDelayed("sm_match")
				period_timer(es.ServerVar("sm_match_period_time"), False)

			tokens = {}
			tokens["name"] = player.name
			lang_msg.tell(messages_text, "match_paused", tokens)
		else:
			es.tell(userid, "#green", messages_text("already_paused", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("no_match_started", None, player.get("lang")))

def unpause(userid):
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 1:
		if es.ServerVar("sm_match_paused") == 1:
			tokens = {}
			tokens["name"] = player.name

			if es.ServerVar("sm_match_period_break") == 0:
				if es.ServerVar("sm_match_paused_delay") == 0:
					es.set("sm_match_paused_delay", 1)

					lang_msg.centertell(messages_text, "get_ready")
					gamethread.delayed(1, lang_msg.centertell_msg, ("| 5 |"))
					gamethread.delayed(2, lang_msg.centertell_msg, ("| 4 |"))
					gamethread.delayed(3, lang_msg.centertell_msg, ("| 3 |"))
					gamethread.delayed(4, lang_msg.centertell_msg, ("| 2 |"))
					gamethread.delayed(5, lang_msg.centertell_msg, ("| 1 |"))
					gamethread.delayed(6, lang_msg.centertell, (messages_text, "go"))

					if es.ServerVar("sm_match_first_hit") == 1:
						gamethread.delayedname(6, "sm_match", gamethread.cancelDelayed, ("sm_match"))
						gamethread.delayedname(6, "sm_match", period_timer, (es.ServerVar("sm_match_period_time"), True))

					gamethread.delayed(6, es.set, ("sm_match_paused_delay", 0))
					gamethread.delayed(6, es.set, ("sm_match_paused", 0))
					gamethread.delayed(6, unfreeze)

					lang_msg.tell(messages_text, "match_unpaused", tokens)
				else:
					es.tell(userid, "#green", messages_text("already_unpaused", None, player.get("lang")))
			else:
				es.set("sm_match_paused", 0)

				lang_msg.tell(messages_text, "match_unpaused", tokens)
		else:
			es.tell(userid, "#green", messages_text("already_unpaused", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("no_match_started", None, player.get("lang")))

def stop(userid):
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_match_started") == 1:
		es.set("sm_match_started", 0)

		unfreeze()
		gamethread.cancelDelayed("sm_match")

		tokens = {}
		tokens["name"] = player.name
		lang_msg.tell(messages_text, "match_stopped", tokens)
	else:
		es.tell(userid, "#green", messages_text("no_match_started", None, player.get("lang")))

def freeze():
	for player in playerlib.getPlayerList("#alive"):
		player.freeze(1)

	es.server.queuecmd("phys_pushscale 1")
	es.server.queuecmd("phys_timescale 0")

def unfreeze():
	for player in playerlib.getPlayerList("#alive"):
		player.freeze(0)

	es.server.queuecmd("phys_pushscale 900")
	es.server.queuecmd("phys_timescale 1")

def period_timer(time, add = False):
	es.set("sm_match_period_time", time)

	minutes = int(time / 60)
	es.set("sm_match_minutes", minutes)

	seconds = int(time - (minutes * 60))
	es.set("sm_match_seconds", seconds)

	if es.ServerVar("sm_match_score_board_on") == 1:
		if es.ServerVar("sm_match_golden_goal") == 1:
			display_score_board(minutes, seconds, 3)
		else:
			display_score_board(minutes, seconds)

	period = int(es.ServerVar("sm_match_period"))
	period_end = period * int(es.ServerVar("sm_match_period_length"))

	if time < period_end:
		if add == True:
			gamethread.delayedname(1, "sm_match", period_timer, (time + 1, True))
		else:
			gamethread.delayedname(1, "sm_match", period_timer, (time, False))
	else:
		if es.ServerVar("sm_match_golden_goal") == 1:
			if add == True:
				gamethread.delayedname(1, "sm_match", period_timer, (time + 1, True))
			else:
				gamethread.delayedname(1, "sm_match", period_timer, (time, False))
		else:
			period += 1
			if period <= int(es.ServerVar("sm_match_periods")):
				freeze()

				es.set("sm_match_period", period)
				es.set("sm_match_period_break", 1)
				period_break_timer(int(es.ServerVar("sm_match_period_break_length")))

				if es.ServerVar("sm_match_sounds_on") == 1:
					es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_period_end"))
			else:
				score_t = int(es.ServerVar("sm_match_score_t"))
				score_ct = int(es.ServerVar("sm_match_score_ct"))

				if score_t > score_ct:
					win_t()
				elif score_t < score_ct:
					win_ct()
				elif score_t == score_ct:
					draw()

def period_break_timer(time):
	if es.ServerVar("sm_match_score_board_on") == 1:
		minutes = int(time / 60)
		seconds = int(time - (minutes * 60))

		display_score_board(minutes, seconds, 2)

	if time < 1:
		es.set("sm_match_period_break", 0)
		es.set("sm_match_kick_off_msg", 1)
		es.server.queuecmd("mp_restartgame 1")
	else:
		gamethread.delayedname(1, "sm_match", period_break_timer, (time - 1))

def display_score_board(minutes, seconds, type = 1):
	if es.exists("keygroup", "sm_keygroup_vote") == 0:
		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		name_t = es.ServerVar("sm_match_short_name_t")
		name_ct = es.ServerVar("sm_match_short_name_ct")

		if type == 1:
			scoreboard = ""
		elif type == 2:
			if es.ServerVar("sm_match_periods") < 3:
				scoreboard = "Half time: "
			else:
				scoreboard = "Period break: "
		elif type == 3:
			scoreboard = "Golden goal: "

		if es.ServerVar("sm_match_swap_names_on") == 0:
			if seconds < 10:
				message = "%s%s:0%s | %s %s - %s %s" % (scoreboard, minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				message = "%s%s:%s | %s %s - %s %s" % (scoreboard, minutes, seconds, name_t, score_t, score_ct, name_ct)
		else:
			if seconds < 10:
				message = "%s%s:0%s | %s %s - %s %s" % (scoreboard, minutes, seconds, name_ct, score_ct, score_t, name_t)
			else:
				message = "%s%s:%s | %s %s - %s %s" % (scoreboard, minutes, seconds, name_ct, score_ct, score_t, name_t)

		for ply in playerlib.getPlayerList("#human"):
			es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, message))

		if int(es.ServerVar("tv_enable")) == 1:
			es.menu(1, int(es.getuserid(es.ServerVar("tv_name"))), message)

def ball_hit():
	if es.ServerVar("sm_match_first_hit") == 0:
		es.set("sm_match_first_hit", 1)
		if es.ServerVar("sm_match_started") == 1:
			if es.ServerVar("sm_match_period_break") == 0:
				gamethread.cancelDelayed("sm_match")
				period_timer(es.ServerVar("sm_match_period_time"), True)

def win_t():
	end()

	for player in playerlib.getPlayerList("#t"):
		popuplib.send("sm_popup_match_win", player.userid)

	for player in playerlib.getPlayerList("#ct"):
		popuplib.send("sm_popup_match_lose", player.userid)

def win_ct():
	end()

	for player in playerlib.getPlayerList("#t"):
		popuplib.send("sm_popup_match_lose", player.userid)

	for player in playerlib.getPlayerList("#ct"):
		popuplib.send("sm_popup_match_win", player.userid)

def draw():
	if es.ServerVar("sm_match_golden_goal_on") == 1:
		es.set("sm_match_golden_goal", 1)
		es.set("sm_match_kick_off_msg", 1)

		freeze()

		if es.ServerVar("sm_match_sounds_on") == 1:
			es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_period_end"))

		tokens = {}
		lang_msg.tell(messages_text, "draw")

		es.server.queuecmd("mp_restartgame %s" % (es.ServerVar("sm_match_restart_length")))
	else:
		end()

def end():
	gamethread.cancelDelayed("sm_match")

	es.set("sm_match_started", 0)

	score_t = es.ServerVar("sm_match_score_t")
	score_ct = es.ServerVar("sm_match_score_ct")

	name_t = es.ServerVar("sm_match_name_t")
	name_ct = es.ServerVar("sm_match_name_ct")

	if es.ServerVar("sm_match_swap_names_on") == 0:
		score = "%s %s - %s %s" % (name_t, score_t, score_ct, name_ct)
	else:
		score = "%s %s - %s %s" % (name_ct, score_ct, score_t, name_t)

	tokens = {}
	tokens["score"] = score
	lang_msg.tell(messages_text, "final_score", tokens)

	if es.ServerVar("sm_match_sounds_on") == 1:
		es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_match_end"))

def change_view(userid, amount = 0):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		if amount == 0:
			amount = random.randint(1, 89)
		es.setplayerprop(userid, "CBasePlayer.m_iDefaultFOV", amount)

def push_player(userid, push):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" % (push))

def explosion(userid):
	player = playerlib.getPlayer(userid)
	if player.isdead == 0:
		es.emitsound("player", userid, "weapons/hegrenade/explode4.wav", "1.0", "0.5")
		x,y,z = es.getplayerlocation(userid)
		pos1 = "%s,%s,%s" % (x, y, z)
		es.server.queuecmd("es_xeffect sparks %s 9999 3 0,0,0" % (pos1))

def kill_player(userid):
	es.server.insertcmd("es_xsexec %s kill" % (userid))

# ******************** Unload ********************
def unload():
	gamethread.cancelDelayed("sm_match")

	popuplib.delete("sm_popup_admin_match")
	popuplib.delete("sm_popup_match_win")
	popuplib.delete("sm_popup_match_lose")

	es.unload("soccer_mod_2011/modules/match/names")
	es.unload("soccer_mod_2011/modules/match/score")