﻿import es
import gamethread
import langlib
import playerlib
import popuplib

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/referee/messages_referee.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/referee/popup_admin_referee.ini")

# ******************** Load ********************
def load():
	global players
	players = {}

	create_popup()

	es.load("soccer_mod_2011/modules/referee/warn")
	es.load("soccer_mod_2011/modules/referee/punish")

# ******************** Events ********************
def es_map_start(event_var):
	global players
	players = {}

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			global players
			if event_var["es_steamid"] in players:
				if players[event_var["es_steamid"]]["red"] == 1:
					player = playerlib.getPlayer(event_var["userid"])
					change_team(player)

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_referee")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("warn")))
	popup.addline("->2. %s" % (popup_text("yellow")))
	popup.addline("->3. %s" % (popup_text("remove_yellow")))
	popup.addline("->4. %s" % (popup_text("red")))
	popup.addline("->5. %s" % (popup_text("remove_red")))
	popup.addline("->6. %s" % (popup_text("clear")))
	popup.addline("->7. %s" % (popup_text("punish")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	popup.submenu(1, "sm_popup_admin_referee_warn")

	for i in range(2, 7):
		popup.select(i, popup_choice)

	popup.submenu(7, "sm_popup_admin_referee_punish")
	popup.submenu(8, "sm_popup_admin_referee")
	popup.submenu(9, "sm_popup_admin")

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	global players

	if choice > 1 and choice < 6:
		name = "sm_popup_%s" % (userid)
		if popuplib.exists(name):
			popuplib.delete(name)

		if choice == 2:
			myPopup = popuplib.easymenu(name, None, give_yellow)

			myPopup.settitle(popup_text("yellow"))

			ordered = []
			for player in playerlib.getPlayerList("#human"):
				ordered.append((player.name, player.userid, player.steamid))
			ordered = sorted(ordered)

			for player in ordered:
				if player[2] not in players:
					myPopup.addoption(player[1], player[0])
				else:
					if players[player[2]]["red"] == 0:
						if players[player[2]]["yellow"] == 1:
							myPopup.addoption(player[1], "%s (%s)" % (player[0], popup_text("yellow")))
						else:
							myPopup.addoption(player[1], player)

		elif choice == 3:
			myPopup = popuplib.easymenu(name, None, remove_yellow)

			myPopup.settitle(popup_text("remove_yellow"))

			ordered = []
			for steamid in players:
				ordered.append((players[steamid]["name"], steamid, players[steamid]["yellow"]))
			ordered = sorted(ordered)

			for player in ordered:
				if player[2] == 1:
					myPopup.addoption(player[1], player[0])

		elif choice == 4:
			myPopup = popuplib.easymenu(name, None, give_red)

			myPopup.settitle(popup_text("red"))

			ordered = []
			for player in playerlib.getPlayerList("#human"):
				ordered.append((player.name, player.userid, player.steamid))
			ordered = sorted(ordered)

			for player in ordered:
				if player[2] not in players:
					myPopup.addoption(player[1], player[0])
				else:
					if players[player[2]]["red"] == 0:
						myPopup.addoption(player[1], player[0])

		elif choice == 5:
			myPopup = popuplib.easymenu(name, None, remove_red)

			myPopup.settitle(popup_text("remove_red"))

			ordered = []
			for steamid in players:
				ordered.append((players[steamid]["name"], steamid, players[steamid]["red"]))
			ordered = sorted(ordered)

			for player in ordered:
				if player[2] == 1:
					myPopup.addoption(player[1], player[0])

		myPopup.submenu(10, "sm_popup_admin_referee")

		popuplib.send(name, userid)

	else:
		players = {}

		player = playerlib.getPlayer(userid)

		tokens = {}
		tokens["name"] = player.name
		lang_msg.tell(messages_text, "clear", tokens)

		popuplib.send("sm_popup_admin_referee", userid)

# ******************** Easymenu choice ********************
def give_yellow(userid, choice, popupid):
	player = playerlib.getPlayer(userid)

	if es.exists("userid", choice) == 1:
		global players

		target = playerlib.getPlayer(choice)

		tokens = {}
		tokens["name"] = player.name
		tokens["target"] = target.name

		if target.steamid not in players:
			players[target.steamid] = {"name": target.name, "yellow": 1, "red": 0}

			es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))

			lang_msg.tell(messages_text, "yellow_given", tokens)
		else:
			if players[player.steamid]["red"] == 0:
				if players[player.steamid]["yellow"] == 0:
					players[target.steamid] = {"name": target.name, "yellow": 1, "red": 0}

					es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))

					lang_msg.tell(messages_text, "yellow_given", tokens)
				else:
					players[target.steamid] = {"name": target.name, "yellow": 0, "red": 1}

					es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))
					gamethread.delayed(0.5, es.cexec_all, ("playgamesound", es.ServerVar("sm_referee_sound_red_card")))
					gamethread.delayed(6, change_team, (target))

					lang_msg.tell(messages_text, "2nd_yellow_given", tokens)
			else:
				es.tell(userid, "#green", messages_text("already_red", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", None, player.get("lang")))

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popuplib.send("sm_popup_admin_referee", userid)

def give_red(userid, choice, popupid):
	player = playerlib.getPlayer(userid)

	if es.exists("userid", choice) == 1:
		global players

		target = playerlib.getPlayer(choice)

		tokens = {}
		tokens["name"] = player.name
		tokens["target"] = target.name

		if target.steamid not in players:
			players[target.steamid] = {"name": target.name, "yellow": 0, "red": 1}

			es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))
			gamethread.delayed(0.5, es.cexec_all, ("playgamesound", es.ServerVar("sm_referee_sound_red_card")))
			gamethread.delayed(6, change_team, (target))

			lang_msg.tell(messages_text, "red_given", tokens)
		else:
			if players[player.steamid]["red"] == 0:
				players[target.steamid] = {"name": target.name, "yellow": 0, "red": 1}

				es.cexec_all("playgamesound", es.ServerVar("sm_referee_sound_whistle"))
				gamethread.delayed(0.5, es.cexec_all, ("playgamesound", es.ServerVar("sm_referee_sound_red_card")))
				gamethread.delayed(6, change_team, (target))

				lang_msg.tell(messages_text, "red_given", tokens)
			else:
				es.tell(userid, "#green", messages_text("already_red", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", None, player.get("lang")))

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popuplib.send("sm_popup_admin_referee", userid)

def remove_yellow(userid, choice, popupid):
	remove_card(userid, choice, 1, 0, "yellow_removed")

def remove_red(userid, choice, popupid):
	remove_card(userid, choice, 0, 1, "red_removed")

def remove_card(userid, choice, yellow, red, msg):
	player = playerlib.getPlayer(userid)

	global players

	if choice in players:
		if players[choice]["yellow"] == yellow and players[choice]["red"] == red:
			tokens = {}
			tokens["name"] = player.name
			tokens["target"] = players[choice]["name"]

			del players[choice]

			lang_msg.tell(messages_text, msg, tokens)
		else:
			es.tell(userid, "#green", messages_text("already_removed", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("already_removed", None, player.get("lang")))

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popuplib.send("sm_popup_admin_referee", userid)

# ******************** Functions ********************
def change_team(player, team = 1):
	if player.team > 1:
		es.server.queuecmd("es_changeteam %s %s" % (player.userid, team))

# ******************** Unload ********************
def unload():
	global players
	del players

	popuplib.delete("sm_popup_admin_referee")

	es.unload("soccer_mod_2011/modules/referee/warn")
	es.unload("soccer_mod_2011/modules/referee/punish")