﻿import datetime
import es
import gamethread
import playerlib
import random
import time

# ******************** Events ********************
def es_map_start(event_var):
	gamethread.cancelDelayed("sm_score_board")

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		gamethread.cancelDelayed("sm_score_board")

		es.set("sm_scoreboard_spawned", 0)

		create_scoreboard()

def player_activate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_scoreboard_spawned") == 0:
			create_scoreboard()

# ******************** Functions ********************
def create_scoreboard():
	map = es.ServerVar("eventscripts_currentmap")
	if es.exists("key", "soccer_mod_scoreboard", map) == 1:

		x = es.keygetvalue("soccer_mod_scoreboard", map, "position_x")
		y = es.keygetvalue("soccer_mod_scoreboard", map, "position_y")
		z = es.keygetvalue("soccer_mod_scoreboard", map, "position_z")

		if x != "" and y != "" and z != "":
			players = playerlib.getUseridList("#all")
			if len(players) > 0:
				position = [int(x), int(y), int(z)]

				index = create_entity("sm_score_board", es.ServerVar("sm_scoreboard_model"), "%s %s %s" % (position[0] - 1, position[1], position[2]), "0 0 0")
				es.set("sm_scoreboard_index", index)

				userid = random.choice(players)
				set_color(userid, "sm_score_board", es.ServerVar("sm_scoreboard_color"))

				gamethread.delayed(0.02, spawn_number, (userid, "sm_score_board_hours_l", [position[0], position[1] - 156, position[2] + 52]))
				gamethread.delayed(0.04, spawn_number, (userid, "sm_score_board_hours_r", [position[0], position[1] - 104, position[2] + 52]))

				gamethread.delayed(0.06, spawn_number, (userid, "sm_score_board_minutes_l", [position[0], position[1] - 26, position[2] + 52]))
				gamethread.delayed(0.08, spawn_number, (userid, "sm_score_board_minutes_r", [position[0], position[1] + 26, position[2] + 52]))

				gamethread.delayed(0.10, spawn_number, (userid, "sm_score_board_seconds_l", [position[0], position[1] + 104, position[2] + 52]))
				gamethread.delayed(0.12, spawn_number, (userid, "sm_score_board_seconds_r", [position[0], position[1] + 156, position[2] + 52]))

				gamethread.delayed(0.14, spawn_number, (userid, "sm_score_board_ct_1", [position[0], position[1] - 156, position[2] - 52]))
				gamethread.delayed(0.16, spawn_number, (userid, "sm_score_board_ct_2", [position[0], position[1] - 104, position[2] - 52]))
				gamethread.delayed(0.18, spawn_number, (userid, "sm_score_board_ct_3", [position[0], position[1] - 52, position[2] - 52]))

				gamethread.delayed(0.20, spawn_number, (userid, "sm_score_board_t_1", [position[0], position[1] + 52, position[2] - 52]))
				gamethread.delayed(0.22, spawn_number, (userid, "sm_score_board_t_2", [position[0], position[1] + 104, position[2] - 52]))
				gamethread.delayed(0.24, spawn_number, (userid, "sm_score_board_t_3", [position[0], position[1] + 156, position[2] - 52]))

				x = es.keygetvalue("soccer_mod_scoreboard", es.ServerVar("eventscripts_currentmap"), "angle_x")
				if x == "":
					x = 0

				y = es.keygetvalue("soccer_mod_scoreboard", es.ServerVar("eventscripts_currentmap"), "angle_y")
				if y == "":
					y = 0

				gamethread.delayed(0.26, es.entitysetvalue, (index, "angles", "%s %s 0" % (x, y)))

				gamethread.delayed(0.28, update)

				es.set("sm_scoreboard_spawned", 1)

def create_entity(name, model, origin, angles):
	index = es.createentity("prop_dynamic")

	es.entitysetvalue(index, "targetname", name)
	es.entitysetvalue(index, "model", model)

	origin = origin.split(" ")
	es.entitysetvalue(index, "origin", "%s %s %s" % (origin[0], origin[1], origin[2]))

	angles = angles.split(" ")
	es.entitysetvalue(index, "angles", "%s %s %s" % (angles[0], angles[1], angles[2]))

	es.server.queuecmd("es_xspawnentity %s" % (index))

	return index

def set_color(userid, name, color):
	es.server.queuecmd('es_xfire %s %s Color "%s"' % (userid, name, color))

def spawn_number(userid, name, origin):
	model = es.ServerVar("sm_scoreboard_model_number")

	create_entity("%s_tm" % (name), model, "%s %s %s" % (origin[0], origin[1], origin[2] + 26), "0 0 90")
	create_entity("%s_mm" % (name), model, "%s %s %s" % (origin[0], origin[1], origin[2]), "0 0 90")
	create_entity("%s_bm" % (name), model, "%s %s %s" % (origin[0], origin[1], origin[2] - 26), "0 0 90")
	create_entity("%s_tl" % (name), model, "%s %s %s" % (origin[0], origin[1] - 13, origin[2] + 13), "0 0 0")
	create_entity("%s_bl" % (name), model, "%s %s %s" % (origin[0], origin[1] - 13, origin[2] - 13), "0 0 0")
	create_entity("%s_tr" % (name), model, "%s %s %s" % (origin[0], origin[1] + 13, origin[2] + 13), "0 0 0")
	create_entity("%s_br" % (name), model, "%s %s %s" % (origin[0], origin[1] + 13, origin[2] - 13), "0 0 0")

	es.server.queuecmd('es_xfire %s %s_tm SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_mm SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_bm SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_tl SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_bl SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_tr SetParent sm_score_board' % (userid, name))
	es.server.queuecmd('es_xfire %s %s_br SetParent sm_score_board' % (userid, name))

def update():
	players = playerlib.getUseridList("#all")
	if len(players) > 0:
		userid = random.choice(players)

		time_color_on = es.ServerVar("sm_scoreboard_time_color_on")
		time_color_off = es.ServerVar("sm_scoreboard_time_color_off")

		if es.ServerVar("sm_match_started") == 1:
			hour = str(0)
			if len(hour) > 1:
				gamethread.delayedname(0.00, "sm_score_board", set_number, (userid, int(hour[0:1]), "sm_score_board_hours_l", time_color_on, time_color_off))
				gamethread.delayedname(0.02, "sm_score_board", set_number, (userid, int(hour[1:2]), "sm_score_board_hours_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.00, "sm_score_board", set_number, (userid, 0, "sm_score_board_hours_l", time_color_on, time_color_off))
				gamethread.delayedname(0.02, "sm_score_board", set_number, (userid, int(hour), "sm_score_board_hours_r", time_color_on, time_color_off))

			minute = str(es.ServerVar("sm_match_minutes"))
			if len(minute) > 1:
				gamethread.delayedname(0.04, "sm_score_board", set_number, (userid, int(minute[0:1]), "sm_score_board_minutes_l", time_color_on, time_color_off))
				gamethread.delayedname(0.06, "sm_score_board", set_number, (userid, int(minute[1:2]), "sm_score_board_minutes_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.04, "sm_score_board", set_number, (userid, 0, "sm_score_board_minutes_l", time_color_on, time_color_off))
				gamethread.delayedname(0.06, "sm_score_board", set_number, (userid, int(minute), "sm_score_board_minutes_r", time_color_on, time_color_off))

			second = str(es.ServerVar("sm_match_seconds"))
			if len(second) > 1:
				gamethread.delayedname(0.08, "sm_score_board", set_number, (userid, int(second[0:1]), "sm_score_board_seconds_l", time_color_on, time_color_off))
				gamethread.delayedname(0.10, "sm_score_board", set_number, (userid, int(second[1:2]), "sm_score_board_seconds_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.08, "sm_score_board", set_number, (userid, 0, "sm_score_board_seconds_l", time_color_on, time_color_off))
				gamethread.delayedname(0.10, "sm_score_board", set_number, (userid, int(second), "sm_score_board_seconds_r", time_color_on, time_color_off))
		else:
			current = datetime.datetime.fromtimestamp(time.time() + (es.ServerVar("sm_scoreboard_set_time") * 60))

			hour = str(current.hour)
			if len(hour) > 1:
				gamethread.delayedname(0.00, "sm_score_board", set_number, (userid, int(hour[0:1]), "sm_score_board_hours_l", time_color_on, time_color_off))
				gamethread.delayedname(0.02, "sm_score_board", set_number, (userid, int(hour[1:2]), "sm_score_board_hours_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.00, "sm_score_board", set_number, (userid, 0, "sm_score_board_hours_l", time_color_on, time_color_off))
				gamethread.delayedname(0.02, "sm_score_board", set_number, (userid, int(hour), "sm_score_board_hours_r", time_color_on, time_color_off))

			minute = str(current.minute)
			if len(minute) > 1:
				gamethread.delayedname(0.04, "sm_score_board", set_number, (userid, int(minute[0:1]), "sm_score_board_minutes_l", time_color_on, time_color_off))
				gamethread.delayedname(0.06, "sm_score_board", set_number, (userid, int(minute[1:2]), "sm_score_board_minutes_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.04, "sm_score_board", set_number, (userid, 0, "sm_score_board_minutes_l", time_color_on, time_color_off))
				gamethread.delayedname(0.06, "sm_score_board", set_number, (userid, int(minute), "sm_score_board_minutes_r", time_color_on, time_color_off))

			second = str(current.second)
			if len(second) > 1:
				gamethread.delayedname(0.08, "sm_score_board", set_number, (userid, int(second[0:1]), "sm_score_board_seconds_l", time_color_on, time_color_off))
				gamethread.delayedname(0.10, "sm_score_board", set_number, (userid, int(second[1:2]), "sm_score_board_seconds_r", time_color_on, time_color_off))
			else:
				gamethread.delayedname(0.08, "sm_score_board", set_number, (userid, 0, "sm_score_board_seconds_l", time_color_on, time_color_off))
				gamethread.delayedname(0.10, "sm_score_board", set_number, (userid, int(second), "sm_score_board_seconds_r", time_color_on, time_color_off))

		score_t = int(es.ServerVar("sm_match_score_t"))
		t_color_on = es.ServerVar("sm_scoreboard_t_color_on")
		t_color_off = es.ServerVar("sm_scoreboard_t_color_off")

		if score_t < 10:
			gamethread.delayedname(0.12, "sm_score_board", set_number, (userid, 0, "sm_score_board_t_1", t_color_on, t_color_off))
			gamethread.delayedname(0.14, "sm_score_board", set_number, (userid, 0, "sm_score_board_t_2", t_color_on, t_color_off))
			gamethread.delayedname(0.16, "sm_score_board", set_number, (userid, score_t, "sm_score_board_t_3", t_color_on, t_color_off))

		elif score_t < 100:
			string = str(score_t)
			gamethread.delayedname(0.12, "sm_score_board", set_number, (userid, 0, "sm_score_board_t_1", t_color_on, t_color_off))
			gamethread.delayedname(0.14, "sm_score_board", set_number, (userid, int(string[0:1]), "sm_score_board_t_2", t_color_on, t_color_off))
			gamethread.delayedname(0.16, "sm_score_board", set_number, (userid, int(string[1:2]), "sm_score_board_t_3", t_color_on, t_color_off))

		elif score_t < 1000:
			string = str(score_t)
			gamethread.delayedname(0.12, "sm_score_board", set_number, (userid, int(string[0:1]), "sm_score_board_t_1", t_color_on, t_color_off))
			gamethread.delayedname(0.14, "sm_score_board", set_number, (userid, int(string[1:2]), "sm_score_board_t_2", t_color_on, t_color_off))
			gamethread.delayedname(0.16, "sm_score_board", set_number, (userid, int(string[2:3]), "sm_score_board_t_3", t_color_on, t_color_off))
		else:
			gamethread.delayedname(0.12, "sm_score_board", set_number, (userid, 9, "sm_score_board_t_1", t_color_on, t_color_off))
			gamethread.delayedname(0.14, "sm_score_board", set_number, (userid, 9, "sm_score_board_t_2", t_color_on, t_color_off))
			gamethread.delayedname(0.16, "sm_score_board", set_number, (userid, 9, "sm_score_board_t_3", t_color_on, t_color_off))

		score_ct = int(es.ServerVar("sm_match_score_ct"))
		ct_color_on = es.ServerVar("sm_scoreboard_ct_color_on")
		ct_color_off = es.ServerVar("sm_scoreboard_ct_color_off")

		if score_ct < 10:
			gamethread.delayedname(0.18, "sm_score_board", set_number, (userid, 0, "sm_score_board_ct_1", ct_color_on, ct_color_off))
			gamethread.delayedname(0.20, "sm_score_board", set_number, (userid, 0, "sm_score_board_ct_2", ct_color_on, ct_color_off))
			gamethread.delayedname(0.22, "sm_score_board", set_number, (userid, score_ct, "sm_score_board_ct_3", ct_color_on, ct_color_off))

		elif score_ct < 100:
			string = str(score_ct)
			gamethread.delayedname(0.18, "sm_score_board", set_number, (userid, 0, "sm_score_board_ct_1", ct_color_on, ct_color_off))
			gamethread.delayedname(0.20, "sm_score_board", set_number, (userid, int(string[0:1]), "sm_score_board_ct_2", ct_color_on, ct_color_off))
			gamethread.delayedname(0.22, "sm_score_board", set_number, (userid, int(string[1:2]), "sm_score_board_ct_3", ct_color_on, ct_color_off))

		elif score_ct < 1000:
			string = str(score_ct)
			gamethread.delayedname(0.18, "sm_score_board", set_number, (userid, int(string[0:1]), "sm_score_board_ct_1", ct_color_on, ct_color_off))
			gamethread.delayedname(0.20, "sm_score_board", set_number, (userid, int(string[1:2]), "sm_score_board_ct_2", ct_color_on, ct_color_off))
			gamethread.delayedname(0.22, "sm_score_board", set_number, (userid, int(string[2:3]), "sm_score_board_ct_3", ct_color_on, ct_color_off))
		else:
			gamethread.delayedname(0.18, "sm_score_board", set_number, (userid, 9, "sm_score_board_ct_1", ct_color_on, ct_color_off))
			gamethread.delayedname(0.20, "sm_score_board", set_number, (userid, 9, "sm_score_board_ct_2", ct_color_on, ct_color_off))
			gamethread.delayedname(0.22, "sm_score_board", set_number, (userid, 9, "sm_score_board_ct_3", ct_color_on, ct_color_off))

		gamethread.delayedname(1, "sm_score_board", update)

def set_number(userid, number, name, color_on, color_off):
	if number == 0:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_on)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_off)

	elif number == 1:
		set_color(userid, "%s_tm" % name, color_off)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_off)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_off)
		set_color(userid, "%s_mm" % name, color_off)

	elif number == 2:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_off)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_on)
		set_color(userid, "%s_tl" % name, color_off)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 3:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_off)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 4:
		set_color(userid, "%s_tm" % name, color_off)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_off)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 5:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_off)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 6:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_off)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_on)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 7:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_off)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_off)
		set_color(userid, "%s_mm" % name, color_off)

	elif number == 8:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_on)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_on)

	elif number == 9:
		set_color(userid, "%s_tm" % name, color_on)
		set_color(userid, "%s_tr" % name, color_on)
		set_color(userid, "%s_br" % name, color_on)
		set_color(userid, "%s_bm" % name, color_on)
		set_color(userid, "%s_bl" % name, color_off)
		set_color(userid, "%s_tl" % name, color_on)
		set_color(userid, "%s_mm" % name, color_on)

# ******************** Unload ********************
def unload():
	gamethread.cancelDelayed("sm_score_board")