﻿import es
import gamethread
import langlib
import playerlib
import popuplib

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/vote/messages_vote.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/vote/popup_vote.ini")

# ******************** Load ********************
def load():
	popup = popuplib.create("sm_popup_vote")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	number = 0

	if es.ServerVar("sm_module_match_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, popup_text("match_start")))
		popup.select(number, match_start)

		number += 1
		popup.addline("->%s. %s" % (number, popup_text("match_stop")))
		popup.select(number, match_stop)

	if es.ServerVar("sm_module_cap_on") == 1:
		number += 1
		popup.addline("->%s. %s" % (number, popup_text("cap_start")))
		popup.select(number, cap_start)

	if number == 0:
		popup.addline(popup_text("no_vote"))

	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	number += 1
	for i in range(number, 10):
		popup.submenu(i, "sm_popup_vote")

	popup = popuplib.create("sm_popup_vote_question")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")
	popup.addline("Question?")
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_common("yes")))
	popup.addline("->2. %s" % (popup_common("no")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 3):
		popup.select(i, popup_choice)

	for i in range(3, 10):
		popup.submenu(i, "sm_popup_vote_question")

	es.set("sm_vote_spam_protect", 0)

# ******************** Events ********************
def es_map_start(event_var):
	gamethread.cancelDelayed("sm_vote_time")

	delete_keygroup()

# ******************** Commands ********************
def cmd_vote():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("keygroup", "sm_keygroup_vote") == 1:
			if es.exists("key", "sm_keygroup_vote", player.steamid) == 0:
				es.tell(userid, "#green", messages_text("cant_vote", None, player.get("lang")))
			else:
				if int(es.keygetvalue("sm_keygroup_vote", player.steamid, "voted")) == 0:
					popuplib.send("sm_popup_vote_question", userid)
				else:
					es.tell(userid, "#green", messages_text("already_voted", None, player.get("lang")))
		else:
			if es.ServerVar("sm_vote_public_on") == 1:
				popuplib.send("sm_popup_vote", userid)
			else:
				if es.exists("key", "soccer_mod_admins", player.steamid) == 1:
					popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", messages_text("public_vote_off", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Popup choice ********************
def match_start(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_training_cannon_on") == 0:
				if es.ServerVar("sm_training_goals_disabled") == 0:
					if es.ServerVar("sm_cap_fight_started") == 0:
						if es.ServerVar("sm_match_started") == 0:
							if len(playerlib.getPlayerList("#t")) > 0 and len(playerlib.getPlayerList("#ct")) > 0:
								tokens["name"] = player.name
								lang_msg.tell(messages_text, "started_match_start", tokens)

								es.set("sm_vote_question", popup_text("match_start_question"))
								es.set("sm_vote_all", 0)
								es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_start_match"))
								es.set("sm_vote_block", "soccer_mod_2011/modules/match/start_match")

								start()
							else:
								es.tell(userid, "#green", messages_text("no_players", None, player.get("lang")))
								popuplib.send("sm_popup_vote", userid)
						else:
							es.tell(userid, "#green", messages_text("match_already_started", None, player.get("lang")))
							popuplib.send("sm_popup_vote", userid)
					else:
						es.tell(userid, "#green", messages_common("no_option_cap", None, player.get("lang")))
						popuplib.send("sm_popup_vote", userid)
				else:
					es.tell(userid, "#green", messages_text("no_vote_goal_disabled", None, player.get("lang")))
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", messages_text("no_vote_cannon_on", None, player.get("lang")))
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", messages_text("vote_already_active", None, player.get("lang")))
			popuplib.send("sm_popup_vote_question", userid)
	else:
		tokens["number"] = es.ServerVar("sm_vote_delay")
		es.tell(userid, "#green", messages_text("wait_use_vote", tokens, player.get("lang")))
		popuplib.send("sm_popup_vote", userid)

def match_stop(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_match_started") == 1:
				if len(playerlib.getPlayerList("#t")) > 0 and len(playerlib.getPlayerList("#ct")) > 0:
					tokens["name"] = player.name
					lang_msg.tell(messages_text, "started_match_stop", tokens)

					es.set("sm_vote_question", popup_text("match_stop_question"))
					es.set("sm_vote_all", 0)
					es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_stop_match"))
					es.set("sm_vote_block", "soccer_mod_2011/modules/match/stop_match_vote")

					start()
				else:
					es.tell(userid, "#green", messages_text("no_players", None, player.get("lang")))
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", messages_text("no_match_started", None, player.get("lang")))
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", messages_text("vote_already_active", None, player.get("lang")))
			popuplib.send("sm_popup_vote_question", userid)
	else:
		tokens["number"] = es.ServerVar("sm_vote_delay")
		es.tell(userid, "#green", messages_text("wait_use_vote", tokens, player.get("lang")))
		popuplib.send("sm_popup_vote", userid)

def cap_start(userid, choice, name):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.ServerVar("sm_vote_spam_protect") == 0:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			if es.ServerVar("sm_match_started") == 0:
				if es.ServerVar("sm_cap_fight_started") == 0:
					tokens["name"] = player.name
					lang_msg.tell(messages_text, "started_cap_start", tokens)

					es.set("sm_vote_question", popup_text("cap_start_question"))
					es.set("sm_vote_all", 1)
					es.set("sm_vote_percentage", es.ServerVar("sm_vote_percentage_start_cap"))
					es.set("sm_vote_block", "soccer_mod_2011/modules/cap/spec_all_vote")

					start()
				else:
					es.tell(userid, "#green", messages_common("no_option_cap", None, player.get("lang")))
					popuplib.send("sm_popup_vote", userid)
			else:
				es.tell(userid, "#green", messages_common("no_option_match", None, player.get("lang")))
				popuplib.send("sm_popup_vote", userid)
		else:
			es.tell(userid, "#green", messages_text("vote_already_active", None, player.get("lang")))
			popuplib.send("sm_popup_vote_question", userid)
	else:
		tokens["number"] = es.ServerVar("sm_vote_delay")
		es.tell(userid, "#green", messages_text("wait_use_vote", tokens, player.get("lang")))
		popuplib.send("sm_popup_vote", userid)

def popup_choice(userid, choice, name):
	player = playerlib.getPlayer(userid)

	if es.exists("keygroup", "sm_keygroup_vote") == 1:
		if es.exists("key", "sm_keygroup_vote", player.steamid) == 1:
			if int(es.keygetvalue("sm_keygroup_vote", player.steamid, "voted")) == 0:
				es.keysetvalue("sm_keygroup_vote", player.steamid, "voted", 1)

				tokens = {}
				tokens["name"] = player.name

				if choice == 1:
					es.set("sm_vote_yes", es.ServerVar("sm_vote_yes") + 1)

					if es.ServerVar("sm_vote_show_votes_on") == 1:
						lang_msg.tell(messages_text, "voted_yes", tokens)

				else:
					es.set("sm_vote_no", es.ServerVar("sm_vote_no") + 1)

					if es.ServerVar("sm_vote_show_votes_on") == 1:
						lang_msg.tell(messages_text, "voted_no", tokens)

				es.set("sm_vote_number", es.ServerVar("sm_vote_number") + 1)
				es.set("sm_vote_yes_percentage", int(round(float(es.ServerVar("sm_vote_yes")) / float(es.ServerVar("sm_vote_players")) * 100, 0)))

				show_time()

				if int(es.ServerVar("sm_vote_number")) >= int(es.ServerVar("sm_vote_players")):
					end_vote()
			else:
				es.tell(userid, "#green", messages_text("already_voted", None, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_text("cant_vote", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("no_vote_active", None, player.get("lang")))

# ******************** Functions ********************
def start():
	es.set("sm_vote_number", 0)
	es.set("sm_vote_yes", 0)
	es.set("sm_vote_no", 0)

	delete_keygroup()
	es.keygroupcreate("sm_keygroup_vote")

	popuplib.find("sm_popup_vote_question").modline(3, es.ServerVar("sm_vote_question"))

	if es.ServerVar("sm_vote_all") == 1:
		number = create_key("#human")
	else:
		number = create_key("#human,#t")
		number += create_key("#human,#ct")

	es.set("sm_vote_players", number)

	if es.ServerVar("sm_vote_sounds_on") == 1:
		es.cexec_all("playgamesound", es.ServerVar("sm_vote_sound_start"))

	tokens = {}
	tokens["command"] = es.ServerVar("sm_vote_command")
	lang_msg.tell(messages_text, "info", tokens)

	vote_time(es.ServerVar("sm_vote_length"))

def create_key(users):
	number = 0
	for ply in playerlib.getPlayerList(users):
		es.keycreate("sm_keygroup_vote", ply.steamid)
		es.keysetvalue("sm_keygroup_vote", ply.steamid, "voted", 0)
		popuplib.send("sm_popup_vote_question", ply.userid)
		number += 1
	return number

def vote_time(time):
	minutes = int(time / 60)

	es.set("sm_vote_minutes", minutes)
	es.set("sm_vote_seconds", time - (minutes * 60))

	show_time()

	if time > 0:
		gamethread.delayedname(1, "sm_vote_time", vote_time, (time - 1))
	else:
		end_vote()

def show_time():
	tokens = {}
	tokens["votes"] = "%s/%s" % (es.ServerVar("sm_vote_number"), es.ServerVar("sm_vote_players"))
	tokens["current"] = int(round(float(es.ServerVar("sm_vote_yes")) / float(es.ServerVar("sm_vote_players")) * 100, 0))
	tokens["needed"] = es.ServerVar("sm_vote_percentage")

	if int(es.ServerVar("sm_vote_seconds")) < 10:
		tokens["time"] = "%s:0%s" % (es.ServerVar("sm_vote_minutes"), es.ServerVar("sm_vote_seconds"))
	else:
		tokens["time"] = "%s:%s" % (es.ServerVar("sm_vote_minutes"), es.ServerVar("sm_vote_seconds"))

	for player in playerlib.getPlayerList("#human"):
		es.server.queuecmd('usermsg hudhint %s "%s"' % (player.userid, messages_text("vote_hudhint", tokens, player.get("lang"))))

def end_vote():
	gamethread.cancelDelayed("sm_vote_time")

	es.msg("#green", es.ServerVar("sm_vote_question"))

	if int(es.ServerVar("sm_vote_yes_percentage")) < int(es.ServerVar("sm_vote_percentage")):
		es.msg("#green", "Answer: No.")
	else:
		es.msg("#green", "Answer: Yes.")
		es.doblock(es.ServerVar("sm_vote_block"))

	es.set("sm_vote_spam_protect", 1)
	gamethread.delayed(es.ServerVar("sm_vote_delay"), es.set, ("sm_vote_spam_protect", 0))

	delete_keygroup()

def delete_keygroup():
	if es.exists("keygroup", "sm_keygroup_vote") == 1:
		es.keygroupdelete("sm_keygroup_vote")

# ******************** Unload ********************
def unload():
	gamethread.cancelDelayed("sm_vote_time")

	delete_keygroup()

	popuplib.delete("sm_popup_vote")
	popuplib.delete("sm_popup_vote_question")